{ Frame Handling Utility
  (c) vIRtECH Ansgar Scherp, Joachim Gelhaus 1995
  real mode and protected mode!
}


unit _Frame;

interface

var   Frames : LongInt;
const FrameHandlerActive : Boolean = false;

procedure InitFrameHandler;
procedure CloseFrameHandler;
procedure ResetFrames;

implementation

uses WinDos;

var OldInt08 : pointer;

{$F+}
procedure FrameHandler; interrupt;
begin
  inc(frames);
  asm
    mov    al,20h
    out    20h,al
  end;
end;
{$f-}

procedure InitFrameHandler;
begin
  {GetIntVec($8,Pointer(@OldHandler^));}
  GetIntVec($8,OldInt08);
  SetIntVec($8,@FrameHandler);
  {program the pit for 90hz}
  Port[$43]:=$34;
  Port[$40]:=$34;
  Port[$40]:=$12;
  Frames := 0;
  FrameHandlerActive := True;
end;



procedure CloseFrameHandler;
begin
  if FrameHandlerActive then begin
    Port[$43]:=$34;
    Port[$40]:=0;
    Port[$40]:=0;
    SetIntVec($8,OldInt08);
    FrameHandlerActive := False;
  end;
end;

procedure ResetFrames;
begin
  Frames := 0;
end;

end.
