{ _TEXTMAP.PAS - Texturemapping at its best
  (c) vIRTUAL tECHNOLOGIES 1996 Ansgar 	Scherp, Joachim Gelhaus		}

{ *** PSEUDO-TEXTUREMAPPING, ALA DOOM-WALLS *** }


procedure PutHalfTextureWindow( sX, sY1, sY2,
                                eX, eY1,eY2    : integer;
                                p : TSprite );
var
  DX,DY,sDY,eDY   : integer;
  ax,ay           : word;
  spX, spY        : integer;
  startY, endY    : integer;

  {X}
  decision1       : integer;
  addSPX          : integer;
  dXINC1,dXINC2   : integer;

  {Y}
  decision2       : integer;
  addSPY          : integer;
  dYINC1,dYINC2   : integer;

  {Start Y}
  decision3       : integer;
  addSPsY         : integer;
  dYINCs1,dYINCs2 : integer;

  {End Y}
  decision4       : integer;
  addSPeY         : integer;
  dYINCe1,dYINCe2 : integer;

begin
  DX   :=  eX - sX;
  sDY  := sY2 - sY1;
  eDY  := eY2 - eY1;

  spx  :=  0;
  ax   := sX;
  {Bresenham Pro Init fr X}
  if dx < p.b - 1 then
      dXINC1 := ((p.b) mod dx) * 2
    else
      dXINC1 := (p.b*2);
  if dx < p.b - 1 then
      dXINC2:=( ((p.b) mod dx) - dx) * 2
    else
      dXINC2:=(p.b - dx) * 2;
  addSPX := (p.b) div dx;
  if dx > p.b-1 then addSPX:=0;
  decision1 := dXINC1 - DX;

  startY := sY1;
  endY   := sY2;

  DY := abs( eY1 - sY1 );
  {Bresenham Pro Init fr START Y}
  if dx < DY then
      dYINCs1 := ( DY mod dx) * 2
    else
      dYINCs1 := DY*2;
  if dx < DY then
      dYINCs2 := ( ( DY mod dx) - dx) * 2
    else
      dYINCs2 := (DY - dx) * 2;
  if eY1<sY1 then
      addSPsY := -1
    else
      addSPsY := 1;

  decision3 := dYINCs1 - DX;

  DY := abs(sY2-eY2);
  {Bresenham Pro Init fr END Y}
  if dx < DY then
      dYINCe1 := (DY mod dx) * 2
    else
      dYINCe1 := DY*2;
  if dx<DY then
      dYINCe2 := ((DY mod dx) - dx) * 2
    else
      dYINCe2 := (DY - dx) * 2;
  if eY2 < sY2 then
      addSPeY := -1
    else
      addSPeY := 1;
  decision4 := dYINCe1 - DX;

  repeat
    ay := trunc( startY );
    DY := abs( trunc( endY-startY ) );
    if dy = 0 then dy := 1;
    spy := 0;
    {Bresenham Pro Init fr Y}
    if dY < (p.t-1) then
         dYINC1 := ( (p.t-1) mod dY) * 2
       else
         dYINC1 := (p.t-1)*2;
    if dY < (p.t-1) then
        dYINC2 := ( ((p.t-1) mod dY) - dY) * 2
      else
        dYINC2 := ((p.t-1) - dY) * 2;

    if dY<(p.t-1) then
        addSPY := (p.t-1) div dY
      else
        addSPY := 0;

    decision2 := dYINC1 - DY;

    repeat
      putpixel( ax, ay, GetPixelFromSprite( spx, spy, p ) );

      {Bresenham Pro fr Y}
      spy := spy + addSPY;
      if decision2 < 0 then
          decision2 := decision2 + dYINC1
        else
          begin
            spy := spy + 1;
            decision2 := decision2 + dYINC2;
          end;
      inc( ay,1 );
    until ay >= endY;
    {Bresenham Pro fr Start Y}
      if decision3 < 0 then
          decision3 := decision3 + dYINCs1
        else
          begin
            startY := startY + addSPsY;
            decision3 := decision3 + dYINCs2;
          end;
    {Bresenham Pro fr End Y}
      if decision4 < 0 then
          decision4 := decision4 + dYINCe1
            else
              begin
                endY := endY + addSPeY;
                decision4 := decision4 + dYINCe2;
              end;
    {Bresenham Pro fr X}
    spx := spx + addSPX;
    if decision1 < 0 then
        decision1 := decision1 + dXINC1
      else
        begin
          spx := spx + 1;
          decision1 := decision1 + dXINC2;
        end;
    if spx > p.b-1 then spx := p.b - 1;
    inc( ax,1 );
  until ax = eX;
end;


{ *** ECHTES TEXTUREMAPPING! NOCH NICHT GANZ RICHTIG UND ZIEMLICH LAHM *** }

type
  TDirection     = ( Top, Bottom, Left, Right );

Procedure PutTextureWindow( VAR p : array of T2DRecordInteger;
                            s : TSprite );
Var
  LeftPolyTab, RightPolyTab :  Array[ 0..199 ] of Integer;
  LeftPicTab1, RightPicTab1,
  LeftPicTab2, RightPicTab2 : Array[ 0..199 ] of real;

  { *** lokale procedures *** }
  Procedure ScanLeft( X1, X2, Y1, LineHeight : integer; Side : TDirection );

  Var
    y : Integer;
    XAdd, Px, Py, PxAdd, PyAdd, x : Single;
    CurrentLine : integer;

  Begin
    XAdd := ( X2 - X1 ) / LineHeight;
    {}
    case Side of
      Top :
        Begin
          Px := s.b;
          Py := 0;
          PxAdd := -s.b/LineHeight;
          PyAdd := 0;
        End;
      Right :
        Begin
          Px := s.b;
          Py := s.t;
          PxAdd := 0;
          PyAdd := -s.t/LineHeight;
        End;
      Bottom :
        Begin
          Px := 0;
          Py := s.t;
          PxAdd := s.b/LineHeight;
          PyAdd := 0;
        End;
      Left :
        Begin
          Px := 0;
          Py := 0;
          PxAdd := 0;
          PyAdd := s.t/LineHeight;
        End;
    end;
    x := X1;
    For y := 0 to LineHeight do
      Begin
        CurrentLine := Y1 + y;
        if ( CurrentLine >= wy1 ) and ( CurrentLine <= wy2 ) then
          begin
            LeftPolyTab[ CurrentLine ] := round(x);
            LeftPicTab1[ CurrentLine ] := Px;
            LeftPicTab2[ CurrentLine ] := Py;
          end;
        X  := X + XAdd;
        Px := Px + PxAdd;
        Py := Py + PyAdd;
      End;
  End;

  Procedure ScanRight( X1, X2, Y1, LineHeight : Integer;
                       Side : TDirection );

  Var
    y : Integer;
    XAdd, Px, Py, PxAdd, PyAdd, x : Single;

    CurrentLine : integer;

  Begin
    XAdd := ( X2 - X1 ) / LineHeight;
    case Side of
      Top :
        Begin
          Px := 0;
          Py := 0;
          PxAdd := s.b / LineHeight;
          PyAdd := 0;
        End;
      Right :
        Begin
          Px := s.b;
          Py := 0;
          PxAdd := 0;
          PyAdd := s.t / LineHeight;
        End;
      Bottom :
        Begin
          Px := s.b;
          Py := s.t;
          PxAdd := 0;
          PyAdd := -s.t / LineHeight;
        End;
      Left :
        Begin
          Px := 0;
          Py := s.t;
          PxAdd := 0;
          PyAdd := -s.t / LineHeight;
        End;
    end;
    x := X1;
    For y := 0 to LineHeight do
      Begin
        CurrentLine := Y1 + y;
        if ( CurrentLine >= wy1 ) and ( CurrentLine <= wy2 ) then
          begin
            RightPolyTab[ CurrentLine ] := round(x);
            RightPicTab1[ CurrentLine ] := Px;
            RightPicTab2[ CurrentLine ] := Py;
          end;
        X  := X + XAdd;
        Px := Px + PxAdd;
        Py := Py + PyAdd;
      End;
  End;


  Procedure ScanConvert( X1, Y1, X2, Y2 : Integer;
                         PLocation : TDirection );
  var
    LineHeight : Integer;

  Begin
    If Y2 < Y1
      Then
        Begin
          SwapInt(X1, X2);
          SwapInt(Y1, Y2);
          LineHeight := integer( longint( Y2 ) - Y1 + 1 );
          ScanLeft(X1, X2, Y1, LineHeight, PLocation );
        End
      Else
        Begin
          LineHeight := integer( longint( Y2 ) - Y1 + 1 );
          ScanRight(X1, X2, Y1, LineHeight, PLocation );
        End;
  End;

Var
  LineWidth : integer;
  x, y : Integer;

  PolyX1, PolyX2 : integer; {polygonline start & end}

  Px1, Px2,
  Py1, Py2,
  PxAdd, PyAdd : Single;
  Max_Y, Min_Y : Integer;

  Offs : word;

  c : Integer;

  Color : byte;

Begin
  { auerhalb des rahmens }
  if ( (p[0].x<wx1) and (p[1].x<wx1) and (p[2].x<wx1) and (p[3].x<wx1) ) or
     ( (p[0].x>wx2) and (p[1].x>wx2) and (p[2].x>wx2) and (p[3].x>wx2) ) or
     ( (p[0].y<wy1) and (p[1].y<wy1) and (p[2].y<wy1) and (p[3].y<wy1) ) or
     ( (p[0].y>wy2) and (p[1].y>wy2) and (p[2].y>wy2) and (p[3].y>wy2) ) then
     exit;
  asm
    mov Max_Y,0
    mov Min_Y,32000
  end;
  {find max min}
  For c := 0 to 3 do
    Begin
      If p[c].y < Min_y Then Min_Y := p[c].y;
      If p[c].y > Max_y Then Max_Y := p[c].y;
    End;
  { oben oder unten ausserhlab des fensters }
  asm
    {if Min_Y < wy1 then Min_Y := wy1;}
    mov ax, Min_Y
    mov bx, wy1
    cmp ax,bx
    jge @@weiter1
      mov Min_Y, bx
    @@weiter1:
    {if Max_Y > wy2 then Max_Y := wy2;}
    mov ax, Max_Y
    mov bx, wy2
    cmp ax,bx
    jle @@weiter2
      mov Max_Y, bx
    @@weiter2:
  end;
  {}
  ScanConvert(p[0].x, p[0].y, p[1].x, p[1].y, Top);
  ScanConvert(p[1].x, p[1].y, p[2].x, p[2].y, Right);
  ScanConvert(p[2].x, p[2].y, p[3].x, p[3].y, Bottom);
  ScanConvert(p[3].x, p[3].y, p[0].x, p[0].y, Left);
  {}
  For y := Min_Y to Max_Y do
    Begin
      PolyX1 := LeftPolyTab [ y ];
      Px1    := LeftPicTab1 [ y ];
      Py1    := LeftPicTab2 [ y ];
      PolyX2 := RightPolyTab[ y ];
      Px2    := RightPicTab1[ y ];
      Py2    := RightPicTab2[ y ];

      LineWidth := PolyX2 - PolyX1 + 1;

      if LineWidth <> 0 then
        begin
          PxAdd := ( Px2 - Px1 ) / LineWidth;
          PyAdd := ( Py2 - Py1 ) / LineWidth;

          x := PolyX1;
          while x < wx1 do
            begin
              Inc( x );
              Px1 := Px1 + PxAdd;
              Py1 := Py1 + PyAdd;
            end;
          if PolyX2 > wx2 then PolyX2 := wx2;
          while ( x <= PolyX2 ) do
            Begin
              Offs := trunc( Px1 ) + s.b * trunc( Py1 );
              if Offs < s.b*s.t then
                  Color := mem[Seg(s.mem^):offs]
                else
                  Color := 0;
              asm
                {putpixel}
                mov ax,y
                mov bx,320
                mul bx
                add ax,x

                mov cl, Color
                les di, ActVPage
                add di,ax

                mov [es:di],cl

                {Inc( X );}
                inc x
              end;

              Px1 := Px1 + PxAdd;
              Py1 := Py1 + PyAdd;

            End;
        end;
    End;

End;

Procedure PutTextureWindow101h( VAR p : array of T2DRecordInteger;
                            s : TSprite );
var b:byte;
    page:word;
    r : array[0..3] of T2DRecordinteger;
    WinX1, WinX2, WinY1, WinY2 : longint;
begin
  GetWindow101h( WinX1, WinY1, WinX2, WinY2 );

  if ((p[0].x > Winx2) and ( p[1].x > Winx2) and (p[2].x > Winx2) and (p[3].x > Winx2)) or
     ((p[0].x < Winx1) and ( p[1].x < Winx1) and (p[2].x < Winx1) and (p[3].x < Winx1)) or
     ((p[0].y > Winy2) and ( p[1].y > Winy2) and (p[2].y > Winy2) and (p[3].y > Winy2)) or
     ((p[0].y < Winy1) and ( p[1].y < Winy1) and (p[2].y < Winy1) and (p[3].y < Winy1)) then
     begin
       exit;
     end;

  page:=0;
  repeat
    r[0].x := CalcPageX( p[0].x ,page);
    r[0].y := CalcPageY( p[0].y ,page);
    r[1].x := CalcPageX( p[1].x ,page);
    r[1].y := CalcPageY( p[1].y ,page);
    r[2].x := CalcPageX( p[2].x ,page);
    r[2].y := CalcPageY( p[2].y ,page);
    r[3].x := CalcPageX( p[3].x ,page);
    r[3].y := CalcPageY( p[3].y ,page);
    ActivePage( ActVPage101h[page] );
    SetWindow( Windows101h[page,1],Windows101h[page,3],
               Windows101h[page,2],Windows101h[page,4]);
    PutTextureWindow( r, s );
    Inc( Page );
  until page > 5;
end;


